(* Name     : Functionals.thy - Special functionals
	      - an Isabelle theory for RALL-
   Author   : David von Oheimb, Technische Universitaet Muenchen
   Copyright: 1994

   created  : 08-Sep-94
   updated  : 05-Oct-94 residuals and Symmetric Quotient
*)

Functionals = Special +


consts

  (* Residuals and Symmetric Quotient *)
  Left_Residual	:: "[('b,'c)rel, ('a,'c)rel] => ('a,'b)rel" ("(__)" [60,61]60)
  Right_Residual:: "[('a,'b)rel, ('a,'c)rel] => ('b,'c)rel" ("(__)" [60,61]60)
  Symm_Quotient	:: "[('c,'a)rel, ('c,'b)rel] => ('a,'b)rel" ("(SyQ'(_,_'))")


rules

  left_res_def	"SR      == -(-SR^)"
  right_res_def	"RS      == -(R^-S)"
  sym_quot_def	"SyQ(R,S) == (RS)(SR)^"


end

