(* Name     : Lattice.tac.ML - tactics for Lattice.thy
   Author   : David von Oheimb, Technische Universitaet Muenchen
   Copyright: 1995

   created  : 31-Jan-95, extracted from Lattice.ML
*)

fun safe_part safe_tf cs = CHANGED o (DETERM o EVERY'[
				TRY o hyp_subst_tac,
				TRY o (fn _ => safe_tac cs),
				fn i => IF_SUBGOAL i (TRY (safe_tf i))]);

fun birfn_tac cs = let  val{hazIs,hazEs,...}=rep_claset cs
     in biresolve_from_nets_tac (build_netpair (Net.empty,Net.empty)
					       (joinrules(hazIs, hazEs))) end;
fun step_tac2 (safe_tf,ss,cs,unsafe_tf) = FIRST' [
			safe_part safe_tf cs,
			CHANGED o(TRY o rot_eq_tac THEN' asm_full_simp_tac ss),
			inst_step_tac cs,
			unsafe_tf APPEND' birfn_tac cs];
fun slow_step_tac2 (safe_tf,ss,cs,unsafe_tf) = 
			safe_part safe_tf cs
			ORELSE'
			(CHANGED o (TRY o rot_eq_tac THEN'
				    asm_full_simp_tac ss) APPEND'
			 inst_step_tac cs APPEND'
			 (unsafe_tf APPEND' birfn_tac cs));

fun fast_tac2 (tf1,ss,cs,tf2) = SELECT_GOAL(DEPTH_SOLVE(
					step_tac2 (tf1,ss,cs,tf2) 1));
fun slow_tac2 (tf1,ss,cs,tf2) = SELECT_GOAL(DEPTH_SOLVE(
					slow_step_tac2 (tf1,ss,cs,tf2) 1));
fun trace_fast_tac2 (tf1,ss,cs,tf2) = 
	DEPTH_SOLVE (print_tac THEN pause_tac THEN step_tac2 (tf1,ss,cs,tf2)1);
fun best_tac2 (tf1,ss,cs,tf2) = SELECT_GOAL (BEST_FIRST (has_fewer_prems 1,
				 size_of_thm) (step_tac2 (tf1,ss,cs,tf2) 1));
